/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * Development of this software was sponsored by the Office of Biological  *
 * and Environmental Research of the U.S. Department of Energy's Office    *
 * of Science.                                                             *
 *                                                                         *
 * Copyright 2011 UChicago Argonne, LLC.                                   *
 *                                                                         *
 * Licensed under the Apache License, Version 2.0 (the "License"); you     *
 * may not use this file except in compliance with the License.  You may   *
 * obtain a copy of the License at                                         * 
 *                                                                         *
 *   http://www.apache.org/licenses/LICENSE-2.0                            *
 *                                                                         *
 * Unless required by applicable law or agreed to in writing, software     *
 * distributed under the License is distributed on an "AS IS" BASIS,       *
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or         *
 * implied.  See the License for the specific language governing           *
 * permissions and limitations under the License.                          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#ifndef MeshVInfo_hpp
#define MeshVInfo_hpp

#include <string>
#include <vector>
#define MPICH_SKIP_MPICXX
#define OMPI_SKIP_MPICXX
#include "mpi.h"
#ifndef MPI_INCLUDED
#define MPI_INCLUDED
#endif
#include "moab/Core.hpp"
#include "moab/Types.hpp"
#include "pargal/pargal.hpp"
extern "C"{
	#include "ParCALFuncs.h"
}
#include "ParCALVarSHnd.hpp"
#include "MBMesh.hpp"

namespace parncl{

class MeshVInfo{
	public:
		//FIXME: const ?
		MeshVInfo(ParCALVarSHnd *pv_shnd);
		// FIXME: Don't assume double
		void get_mesh_vinfo(MBMesh *&mesh, moab::Interface *&mb_core, nc_type &data_type, size_t &var_chunk_sz, std::vector<pargal::pcdim> &pcvar_dims, std::string &pcvar_loc, double &missing_val, const std::vector<size_t> &var_dims) const;

	private:
		MeshVInfo();

		MBMesh *mesh_;
		moab::Interface *mb_core_;
		nc_type data_type_;
		std::string pcvar_loc_;
		std::vector<pargal::pcdim> pcvar_dims_;
		size_t var_chunk_sz_;
		// FIXME: Don't assume double
		double pcvar_missing_val_;
};

} // namespace parncl

#endif // MeshVInfo_hpp
